from setuptools import setup, find_packages

setup(
    name='YWP',
    version='20.0.0rc4',
    packages=find_packages(),
    install_requires=[
        "dill==0.3.8",
        "flask==3.0.3",
        "flask-cors==4.0.1",
        "gtts==2.5.1",
        "joblib==1.4.2",
        "moviepy==1.0.3",
        "nltk==3.8.1",
        "pyaudio==0.2.14",
        "pygame==2.5.2",
        "selenium==4.22.0",
        "setuptools==68.1.2",
        "sounddevice==0.4.7",
        "SpeechRecognition==3.10.4",
        "tensorflow==2.16.1",
        "tflearn==0.5.0",
        "twine==5.1.0",
        "wheel==0.43.0",
        "pycryptodome==3.20.0",
        "vosk==0.3.45",
        "tqdm==4.66.4",
        "pyttsx3==2.90",
        "requests==2.31.0",
        "googletrans==4.0.0rc1",
        "cryptography==42.0.5",
        "scapy==2.5.0",
        "python-nmap==0.7.1",
        "yara-python==4.5.1",
        "pillow==10.4.0",
    ],
    classifiers=[
        'Programming Language :: Python :: 3',
    ],
    python_requires='>=3.6',
    description='This is a library to simplify the Python language for beginners while adding some features that are not found in other libraries',
    long_description=open('README.md').read(),
    long_description_content_type='text/markdown',
    author='Your Wanted Products (YWP)',
    author_email='pbstzidr@ywp.freewebhostmost.com',
    entry_points={
        'console_scripts': [
            'YWP.install_packages=YWP:inuser.install_system_packages',
            'YWP.install_libraries=YWP:inuser.install_library_packages',
            'YWP.upgrade_libraries=YWP:inuser.upgrade_required_libraries',
            'YWP.upgrade_library=YWP:inuser.upgrade_library',
            'YWP=YWP:help',
            'YWP.help=YWP:help',
        ],
    },
)
